# gui.py
# basiert auf Demo_mit_StaticText&TextCtrl_ENTER.py

import wx
import os
from textDialog import TextDialog

##from raumplanerController import RaumplanerController
##from grafikfenster import Zeichenflaeche

### ---------------------------------------------------
class Gui(wx.Frame):
    def __init__(
            self, parent, ID, title, pos=(650,50), # neu
            size=wx.DefaultSize, style=wx.DEFAULT_FRAME_STYLE
            ):

        wx.Frame.__init__(self, parent, ID, title, pos, size, style)
        self.__controller = None
        self.__zf = None
        panel = wx.Panel(self, -1)

        ### Label und TextCtrl
        self.label1 = wx.StaticText(panel, -1, u"ausgewählt")
        self.label1.SetPosition((155, 15))
        self.textCtrl1 = wx.TextCtrl(panel, -1,
                                     "keines",
                                     size=(205, -1))
        self.textCtrl1.SetPosition((155, 45))

        ### Menu-Abschnitt
        # Prepare the menu bar
        menuBar = wx.MenuBar()

        # erstes Menue
        dateiMenu = wx.Menu()
        dateiMenu.Append(101, "Oeffnen")
        dateiMenu.Append(102, "Speichern")
        dateiMenu.AppendSeparator()
        dateiMenu.Append(103, "Beenden")
        # Add menu to the menu bar
        menuBar.Append(dateiMenu, "Datei")

        # zweites Menue
        neuMenu = wx.Menu()
        neuMenu.Append(201, "Stuhl", "")
        neuMenu.Append(202, "Tisch", "")
        neuMenu.Append(203, "Schrank", "")
        neuMenu.Append(204, "Sessel", "")
        neuMenu.Append(205, "Sofa", "")
        neuMenu.Append(206, "Ovaler Tisch", "")
        neuMenu.Append(207, "Bett", "")
        neuMenu.AppendSeparator()
        neuMenu.Append(208, "Herd", "")
        neuMenu.AppendSeparator()
        neuMenu.Append(209, "Badewanne", "")
        neuMenu.Append(210, "Dusche", "")
        neuMenu.Append(211, "Klosett", "")
        ##neuMenu.AppendSeparator()
        # Add menu to the menu bar
        menuBar.Append(neuMenu, "&Moebel")
        
        # drittes Menue
        bearbeitenMenu = wx.Menu()
        bearbeitenMenu.Append(301, "Wähle")
        bearbeitenMenu.Append(302, "Verberge")
        bearbeitenMenu.Append(303, "Zeige")
        bearbeitenMenu.Append(304, "Lösche")
        bearbeitenMenu.AppendSeparator()
        bearbeitenMenu.Append(305, "Text einfügen")
        bearbeitenMenu.Append(306, "Text bearbeiten")

        ##neuMenu.AppendSeparator()
        # Add menu to the menu bar
        menuBar.Append(bearbeitenMenu, "&Bearbeiten")
        
        # viertes Menue
        bildMenu = wx.Menu()
        bildMenu.Append(401, "Bild speichern (png/jpg)", "")
        menuBar.Append(bildMenu, "B&ild")
        
        self.SetMenuBar(menuBar)

        ### Menu events
        self.Bind(wx.EVT_MENU, self.OnOeffnen, id=101)
        self.Bind(wx.EVT_MENU, self.OnSpeichern, id=102)
        self.Bind(wx.EVT_MENU, self.OnBeenden, id=103) ## Korrektur

        self.Bind(wx.EVT_MENU, self.OnStuhl, id=201)
        self.Bind(wx.EVT_MENU, self.OnTisch, id=202)
        self.Bind(wx.EVT_MENU, self.OnSchrank, id=203)
        self.Bind(wx.EVT_MENU, self.OnSessel, id=204)
        self.Bind(wx.EVT_MENU, self.OnSofa, id=205)
        self.Bind(wx.EVT_MENU, self.OnOvalerTisch, id=206)
        self.Bind(wx.EVT_MENU, self.OnBett, id=207)
        self.Bind(wx.EVT_MENU, self.OnHerd, id=208)
        self.Bind(wx.EVT_MENU, self.OnBadewanne, id=209)
        self.Bind(wx.EVT_MENU, self.OnDusche, id=210)
        self.Bind(wx.EVT_MENU, self.OnKlosett, id=211)

        self.Bind(wx.EVT_MENU, self.OnWaehle, id=301)
        self.Bind(wx.EVT_MENU, self.OnVerberge, id=302)
        self.Bind(wx.EVT_MENU, self.OnZeige, id=303)
        self.Bind(wx.EVT_MENU, self.OnLoesche, id=304)
        self.Bind(wx.EVT_MENU, self.OnText, id=305)
        self.Bind(wx.EVT_MENU, self.OnTextBearbeiten, id=306)

        self.Bind(wx.EVT_MENU, self.OnBild, id=401)

        ### Button-Abschnitt
        waehleButton = wx.Button(panel, 1001, u"wähle")
        waehleButton.SetPosition((15, 10))
        self.Bind(wx.EVT_BUTTON, self.OnWaehle, waehleButton)
        
        dreheButton = wx.Button(panel, 1002, "drehe")
        dreheButton.SetPosition((15, 50))        
        self.Bind(wx.EVT_BUTTON, self.OnDrehe, dreheButton)
        
        beendenButton = wx.Button(panel, 1003, "Beenden")
        beendenButton.SetPosition((155, 115))
        self.Bind(wx.EVT_BUTTON, self.OnBeenden, beendenButton)
        ### Fensterereignis
        self.Bind(wx.EVT_CLOSE, self.OnCloseWindow)

    def SetzeController(self,controller):
        self.__controller = controller

    def SetzeZeichenflaeche(self, zf):
        self.__zf=zf
        
    def AusgewaehltIst(self, text):
        self.textCtrl1.ChangeValue(text)

    ### Ereignisbehandlung ###
        
    ### Menu-Abschnitt
    def OnOeffnen(self, event):
        if wx.PlatformInfo[1]=='wxMSW':
            standardVerzeichnis=os.getcwd()+"\\Daten"
        else:
            standardVerzeichnis="Daten"
        dlg = wx.FileDialog(
            self, message=u"Datei wählen",
            defaultDir=standardVerzeichnis,
            defaultFile="daten.dat",
            style=wx.FD_OPEN
            )
        if dlg.ShowModal() == wx.ID_OK:
            dateiname = dlg.GetPath()
            antwort=self.__controller.Lade(dateiname)
            if antwort!='OK':
                message = wx.MessageDialog(self, antwort,
                                           'Achtung',
                                           wx.OK | wx.ICON_WARNING)
                message.ShowModal()
                message.Destroy()
        dlg.Destroy()

    def OnSpeichern(self, event):
        if wx.PlatformInfo[1]=='wxMSW':
            standardVerzeichnis=os.getcwd()+"\\Daten"
        else:
            standardVerzeichnis="Daten"
        dlg = wx.FileDialog(
            self, message="Datei speichern",
            defaultDir=standardVerzeichnis, 
            defaultFile="daten.dat", style=wx.FD_SAVE
            )
        if dlg.ShowModal() == wx.ID_OK:
            dateiname = dlg.GetPath()
            antwort=self.__controller.Speichere(dateiname)
            if antwort!='OK':
                message = wx.MessageDialog(self, antwort,
                                           'Achtung',
                                           wx.OK | wx.ICON_WARNING)
                message.ShowModal()
                message.Destroy()
        dlg.Destroy()

    ### Moebel - Menue
    def OnStuhl(self, event):
        self.__controller.Neu('Stuhl', sichtbar=True)

    def OnTisch(self, event):
        self.__controller.Neu('Tisch', sichtbar=True)

    def OnSchrank(self, event):
        self.__controller.Neu('Schrank', sichtbar=True)

    def OnSessel(self, event):
        self.__controller.Neu('Sessel', sichtbar=True)

    def OnSofa(self, event):
        self.__controller.Neu('Sofa', sichtbar=True)

    def OnOvalerTisch(self, event):
        self.__controller.Neu('OvalerTisch', sichtbar=True)

    def OnBett(self, event):
        self.__controller.Neu('Bett', sichtbar=True)

    def OnHerd(self, event):
        self.__controller.Neu('Herd', sichtbar=True)

    def OnBadewanne(self, event):
        self.__controller.Neu('Badewanne', sichtbar=True)

    def OnDusche(self, event):
        self.__controller.Neu('Dusche', sichtbar=True)

    def OnKlosett(self, event):
        self.__controller.Neu('Klosett', sichtbar=True)

    def OnText(self, event):
        dialog=TextDialog(self, -1,"Text konfigurieren" , size=(350, 200))
        dialog.CenterOnScreen()
        result=dialog.ShowModal()
        if dialog.OKAngeklickt(result):
            try:
                inhalt=dialog.textInhalt.GetValue()
                x=int(dialog.textX.GetValue())
                y=int(dialog.textY.GetValue())
                w=int(dialog.textWinkel.GetValue())
                f=dialog.textFarbe.GetValue()
            except ValueError as e:
                self.Meldung('x,y,Winkel: Ganze Zahl eingeben!')
                return
            self.__controller.NeuerText(inhalt,x,y,w,f,None)

    def OnTextBearbeiten(self, event):
        texte=self.__controller.GibAlleTexte()
        inhalte=[]
        gewaehlt=None
        for text in texte:
            inhalte.append(text.GibText())
        dlg = wx.SingleChoiceDialog(
                self, 'Wähle', 'Textinhalte sind',
                inhalte,
                wx.CHOICEDLG_STYLE
                )
        if dlg.ShowModal() == wx.ID_OK:
            gewaehlt=texte[inhalte.index(dlg.GetStringSelection())]
        dlg.Destroy()
        if gewaehlt==None: return

        dialog=TextDialog(self, -1,"Text konfigurieren" , size=(350, 200))
        typ,inhalt,x,y,w,f,font=gewaehlt.GibDaten()
        dialog.DatenSetzen(inhalt,str(x),str(y),str(w),f)
        dialog.CenterOnScreen()
        result=dialog.ShowModal()
        if (dialog.OKAngeklickt(result)):
            try:
                inhalt=dialog.textInhalt.GetValue()
                x=int(dialog.textX.GetValue())
                y=int(dialog.textY.GetValue())
                w=int(dialog.textWinkel.GetValue())
                f=dialog.textFarbe.GetValue()
            except ValueError as e:
                self.Meldung('x,y,Winkel: Ganze Zahl eingeben!')
                return
            self.__controller.LoescheText(gewaehlt)
            self.__controller.NeuerText(inhalt,x,y,w,f,None)
        

    def OnBild(self, event):
        '''Bild speichern mit Dateidialog'''
        if wx.PlatformInfo[1]=='wxMSW':
            standardVerzeichnis=os.getcwd()+"\\Bilder"
        else:
            standardVerzeichnis="Bilder"
        dlg = wx.FileDialog(
            self, message="Bild in Datei speichern (png/jpg)",
            defaultDir=standardVerzeichnis, 
            defaultFile="Bild.png", style=wx.FD_SAVE
            )
        if dlg.ShowModal() == wx.ID_OK:
            dateiname = dlg.GetPath()
            antwort=self.__zf.BildExport(dateiname)
            if antwort!='OK':
                message = wx.MessageDialog(self, antwort,
                                           'Achtung',
                                           wx.OK | wx.ICON_WARNING)
                message.ShowModal()
                message.Destroy()
        dlg.Destroy()

    ### -----        
    def OnWaehle(self, event):
        ausgewaehlt=self.__controller.Waehle() # neu
    
    def OnVerberge(self, event):
        self.__controller.VerbergeAusgewaehltes()

    def OnZeige(self, event):
        self.__controller.ZeigeAusgewaehltes()

    def OnLoesche(self, event):
        self.__controller.LoescheAusgewaehltes()

    def OnDrehe(self, event):
        self.__controller.Drehe(30)
    
    def OnBeenden(self, event):
        self.Close(True)

    def OnCloseWindow(self, event):
        self.Destroy()

##### ---------------------------------------------------
##class RaumplanerApp(wx.App):
##    """Anwendung fuer Raumplaner"""
##    def OnInit(self):
##        self.fenster = Gui(None, 1000, "Raumplaner")
##        self.SetTopWindow(self.fenster)
##        self.fenster.Show(True)
##        return True
##
##### ---------------------------------------------------
##if __name__ == '__main__':
##    app = RaumplanerApp(redirect=False)
##    app.MainLoop()
