# -*- coding: utf-8 -*-
# text.py

from grafikfenster import *

### ---------------------------------------------------
class Text():
    """Die Klasse Text ermoeglicht das Zeichnen und Bearbeiten von Texten.
    Da Text 'ist ein Moebel' sinnlos ist, muss die Klasse die
    notwendigen Methoden selbst implementieren"""

    def __init__(self,
                 text="",
                 xPos=0,
                 yPos=0,
                 winkel=0,
                 farbe="black",
                 font=None):
        self.__text = text
        self.__x=xPos
        self.__y=yPos
        self.__winkel=winkel
        self.__f=farbe
        self.__s=True
        self.__font = font # nur bei besonderen Zeichen
        self.Zeige()

    def GibText(self):
        '''gibt den string zurueck'''
        return self.__text

    def IstText(self):
        '''Zur Trennung bei der Darstellung von Moebelobjekten'''
        return True

    def GibFont(self):
        '''gibt das von SetzeFont gesetzte font-Objekt zurueck, sonst None'''
        return self.__font

    def SetzeFont(self,
                  pointSize=10,
                  family="DEFAULT",
                  style="NORMAL",
                  weight="FETT",
                  underline=False):
        '''pointSize: 10 ...
        family: "DEFAULT","ROMAN","SWISS"
        style: "NORMAL","KURSIV"
        weight: "NORMAL","FETT"'''
        self.Verberge()
        ff={"DEFAULT":wx.FONTFAMILY_DEFAULT,
            "ROMAN":wx.FONTFAMILY_ROMAN,
            "SWISS":wx.FONTFAMILY_SWISS}
        if not family in ff: family="DEFAULT"
        st={"NORMAL":wx.FONTSTYLE_NORMAL,"KURSIV":wx.FONTSTYLE_ITALIC}
        if not style in st: style="NORMAL"
        w={"NORMAL":wx.FONTWEIGHT_NORMAL ,"FETT":wx.FONTWEIGHT_BOLD}
        if not weight in w: weight="FETT"
        self.__font=wx.Font(pointSize,
                            ff[family],
                            st[style],
                            w[weight],
                            underline)
        self.Zeige()
    
    def GibFuellfarbe(self):
        """Texte haben keine Fuellfarbe"""
        return None
    
    def GibFigur(self):
        """Definiert den Pfad und transformiert ihn."""
        return None
    
    def AendereText(self, text):
        self.Verberge()
        self.__text = text
        self.Zeige()

    def Transformiere(self, path):
        """Transformiert den übergebenen Pfad"""
        gc = Zeichenflaeche.GibZeichenflaeche().GibGC()
        gc.PushState()
        # Hilfvariable verwenden
        x,y = self.GibXPosition(), self.GibYPosition()
        w = self.GibOrientierung()
        gc.Translate(x, y)
        gc.Rotate(radians(w))
        transformation = gc.GetTransform()
        gc.PopState()
        path.Transform(transformation)
        return path

    def GibX(self):
        """Get-Methode fuer die xPosition"""
        return self.__x

    def GibY(self):
        """Get-Methode fuer die yPosition"""
        return self.__y
    
    def GibWinkel(self):
        """Get-Methode fuer den Winkel"""
        return self.__winkel
    
    def GibFarbe(self):
        """Get-Methode fuer die Farbe"""
        return self.__f

    def GibSichtbar(self):
        return self.__s

    def GibDaten(self):
        '''Fuer die Speicherung'''
        return ('Text',self.__text,self.__x,self.__y,
                self.__winkel,self.__f,self.__font)

    def Verberge(self):
        """Veraendernde Methode fuer die Sichtbarkeit mit Wert False"""
        self.__s = False
##        Zeichenflaeche.GibZeichenflaeche().EntferneText(self)

    def Zeige(self):
        """Veraendernde Methode fuer die Sichtbarkeit mit Wert True"""
        self.__s = True
##        Zeichenflaeche.GibZeichenflaeche().ZeichneText(self)

        
### ---------------------------------------------------
class TextApp(wx.App):
    """Test-Anwendung speziell fuer Sessel"""
    def OnInit(self):
        self.__fenster = GrafikFenster(None, "Raumplaner-Grafik")
        self.SetTopWindow(self.__fenster)
        self.__fenster.Show(True)
        self.__fenster.panel.Refresh()
        self.TestAnwendung()
        self.__fenster.ZeigeShellFrame()
        #self.__fenster.ZeigeFillingFrame()
        return True

    def TestAnwendung(self):
        # Allein fuer die Testanwendung:
        global text0,text1,text2
        text0=Text("Grafikfenster",20,200,90,'BLUE')
        text1=Text("Testtext", 200, 40, 0, 'RED')
        text1.SetzeFont(18,"ROMAN","KURSIV","NORMAL",True)
        text2=Text("2. Testtext", 200, 140)

    def TestAendern(self):
        global text0,text1,text2, gruppe
        text0.AendereText("nanu")
        text1.AendereText("neuer Text")
        text2.AendereText("Ach so!")

### ---------------------------------------------------
if __name__ == '__main__':
    app = TextApp(redirect=False)
    # Parameterwert True, wenn Ausgaben in der Standard E/A angezeigt werden sollen
    app.MainLoop()
